﻿using BA.API;
using BA.Core;
using BA.Core.Configuration.OrmEntityBase.EntityFields;
using BA.Core.Configuration.Workflow.Controls.Actions;
using BA.Core.CustomAttributes;
using BA.Core.CustomAttributes.Validations;
using BA.Core.DataProviders.Configuration;
using BA.Core.DB;
using BA.Core.Enums;
using System;
using System.ComponentModel;
using System.Linq;

namespace $safeprojectname$.Configuration.Workflow
{
    [Serializable]
    [Toolbox(EnumConfigurationType.WorkflowConfigurationGuid)]
    public class SetTextFieldWFAction : WorkflowActionBaseControl
    {
        public SetTextFieldWFAction()
        {
            Id = new Guid("09CE6539-3BB1-498C-9C28-57C11FF8262D");
            ToolboxName = "Setze Wert in ein Textfeld";
            ControlInitName = "WorkflowActionSetTextField";
            ToolboxGroupName = Constants.Designer.ToolboxGroups.Workflow.Actions;
            Icon = Constants.Icons.Designer.Workflow.ChangeFieldAction;
        }

        [ComboboxControl]
        [CDPOrmFieldsProperties(typesToShow: new[] { EnumDataTypes.StringGuid }, includeReadOnly: ReadOnlyMode.NoUIWrite)]
        [CDPDataSourceModifier(UseConfiguration = true)]
        [BARequired]
        [DisplayName("Feldname")]
        public String OrmFieldName { get; set; }

        [BARequired]
        [DisplayName("Wert")]
        public String Value { get; set; }

        /// <inheritdoc/>
        protected override bool ExecuteAction(OrmBABase orm, OrmLogBase logger)
        {
            orm.SetMemberValue(OrmFieldName, Value);
            return true;
        }

        /// <inheritdoc/>
        protected override string GetWFControlName()
        {
            return "Setze '" + OrmFieldName + "' auf '" + Value + "'";
        }
    }
}