﻿module $safeprojectname$ {
    "use strict";
    export class Actions {
        public static ClientActionAddService(event: any, customData: CustomData) {
            if (customData.DialogAuthorized) {
                let paramter: CustomData = {};
                paramter.RemarkMessage = customData.RemarkMessage;
                paramter.ServiceDate = customData.ServiceDate;
                BA.Ui.Dialog.DialogManager.OpenDialog("$safeprojectname$.AddServiceDialog", customData, customData,
                    function (result: BA.Ui.Dialog.DialogResult, customData: CustomData) {
                        if (result.ButtonId == 'okButton') {
                            Actions.StartAddServiceMassOperation(event, customData, result.Data.Remark, result.Data.Date);
                        }
                    }
                );
            } else if (!customData.RemarkMessage || customData.RemarkMessage == "")
                BA.Ui.Translations.TranslationTools.GetTranslation("d49ef787-3ad1-4f66-bb12-b2660fd71738", function (result) {
                    BA.Ui.Toast.Warning(result);
                });
            else
                Actions.StartAddServiceMassOperation(event, customData, customData.RemarkMessage, customData.ServiceDate);
        }

        public static CreateDefaultEngineRecord(event: any, customData: CustomData) {
            if (window.GridView) {
                var keys: any[] = window.GridView.GetSelectedKeysOnPage();
                BA.Ui.TabController.TabTools.OpenTab("TrainingHelper/CreateEngineRecord?DefaultName=" + customData.DefaultName + "&SelectedOid=" + keys[0]);
            } else {
                BA.Ui.TabController.TabTools.OpenTab("TrainingHelper/CreateEngineRecord?DefaultName=" + customData.DefaultName);
            }
        }

        public static StartAddServiceMassOperation(event: any, customData: CustomData, remark: any, date: any) {
            let igniterParams: CustomData = {};
            igniterParams.RemarkMessage = remark;
            igniterParams.ServiceDate = date;
            customData["MassOperationIgniterParameters"] = JSON.stringify(igniterParams);
            BA.Ui.Actions.GridActions.StartMassOperation(event, customData);
        }

        public static InputButton(button: BA.Ui.Dialog.BADialogButton, evt: ASPxClientButtonClickEventArgs) {
            var texts = [];
            var titleGuid = "41aba083-e37a-4709-98d4-1d685496459c";
            var messageGuid = "5d49a7fe-8165-4fdc-953f-a194bcffce26";
            texts.push(titleGuid);
            texts.push(messageGuid);
            BA.Ui.Translations.TranslationTools.GetTranslations(texts, function (results) {
                BA.Ui.MessageBox.ShowPrompt(results[titleGuid], results[messageGuid], 200, function (result) {
                    let textBoxName: string = BA.Ui.Dialog.DialogManager.GetDialogControlName(button, "Remark");
                    if (window[textBoxName]) {
                        let box: BAClientTextBox = <BAClientTextBox>window[textBoxName];
                        box.SetValue(result);
                    }
                });
            }, false);
        }
    }

    window.setTimeout(
        function () {
            BA.Ui.Actions.ActionHandler.RegisterAction("$safeprojectname$.ClientActionAddService", Actions.ClientActionAddService);
            BA.Ui.Actions.ActionHandler.RegisterAction("$safeprojectname$.CreateDefaultEngineRecord", Actions.CreateDefaultEngineRecord);
        },
        10
    );
}