declare module BA.Ui.ClientSideControls.List {
    /** contains the core-supplied types of cell data */
    enum ListControlDataType {
        Text = "text",
        Image = "image",
        Number = "number"
    }
    /** definition of a single hover action */
    interface ListRowAction {
        Id: Classes.Guid;
        Title: string;
        IconUrl: string;
        ActionMethodId: string;
        VisibilityFunction?: string;
        ActionParameters?: CustomData;
    }
    /** definition of the anchor where a list is created on */
    interface ListContainer extends HTMLDivElement {
        CustomProperties: CustomData;
        ActiveFilters: CustomData;
        ListInstance: List;
    }
    /** list control column, substitute for dxDataGridColumn */
    interface ListColumn extends DevExpress.ui.dxDataGridColumn {
    }
    /** list control toolbar item, substitute for dxToolbarItem */
    interface ListToolbarItem extends DevExpress.ui.dxToolbarItem {
        type: string;
    }
    /** list control list element, substitute for dxDataGrid */
    interface List extends DevExpress.ui.dxDataGrid {
    }
    /** the parameters needed to create a new list control */
    interface ListControlCreateParameters {
        anchor: ListContainer;
        listDataController: string;
        rowActions: ListRowAction[];
        columns: ListColumn[];
        toolbarItems: ListToolbarItem[];
        rowClickMethodId: string;
        rowDoubleClickMethodId: string;
        showTotalCount: boolean;
        additionalServiceParameters: CustomData;
        customProperties: CustomData;
        contentReadyMethodId: string;
        allowSelection: boolean;
        key: string;
    }
}
