declare module BA.Ui.ClientSideControls.List {
    /** String literal type that defines the available filter types */
    type ListFilterType = "selection" | "custom";
    /** String literal type that defines the available filter locations in the toolbar */
    type ToolbarFilterLocation = "before" | "after";
    /** The toolbar type, substitue for dxDataGrid.Toolbar */
    interface Toolbar extends DevExpress.ui.dxDataGrid.Toolbar {
    }
    /** Definition of a list control toolbar filter entry */
    interface ListFilterEntry {
        value: string;
        text: string;
    }
    /** Definition of a list filter */
    interface ListFilter {
        id: BA.Classes.Guid;
        type: ListFilterType;
        customType: string;
        items: ListFilterEntry[];
        defaultSelected: string;
        triggerFilterRefresh: boolean;
    }
    /** Definition of a list control toolbar filter */
    interface ToolbarListFilter extends ListFilter {
        location: ToolbarFilterLocation;
        width: number;
    }
    /** High-level definition of the available list control toolbar element types */
    type ToolbarElements = BA.Ui.Types.Permutations<"filters">;
}
