declare module BA.Ui.Controls {
    /**
     * Events that get triggered in context with the controls
     **/
    class ButtonControlEvents {
        static Init(s: ASPxClientButton, e: ASPxClientEventArgs): void;
        /** Handle button click event
         * @param s
         * @param e
         * @param customData data for the action
         * @param methodId optional client action ID to execute first
         * @description The UI events are not raised if the client action returned false.
         * The customData may contain a property 'FormActionId'. This causes a server side button action to be performed.
         * It also may contain a comma separated list of field names in 'TriggerFieldChange'.
         * This causes a simulated field change event for every field name in the list.
         * Bothe property might be modified (or cleard) by the optional client action.
         */
        static OnButtonClicked(s: ASPxClientButton, e: ASPxClientEditClickEventArgs, customData: CustomData, methodId?: string): void;
    }
}
